<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: commons.inc.php 379 2010-07-27 15:11:41Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##
session_start();
if(function_exists('date_default_timezone_set')){
	@date_default_timezone_set('Asia/Shanghai');
}
$mtime = explode(' ', microtime());
$ps_time = $mtime[1] + $mtime[0];
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	define('LF',"\r\n");
} else {
	define('LF',"\n");
}
define('NOW_YEAR','2010');
define('XCODE','pd');
$timestamp = time();
define('PHPDISK_ROOT', substr(dirname(__FILE__), 0, -8));
define('PD_PLUGINS_DIR',PHPDISK_ROOT.'./plugins/');
define('IN_PHPDISK',TRUE);
define('SERVER_NAME',$_SERVER['SERVER_NAME']);
@set_magic_quotes_runtime(0);

require_once PHPDISK_ROOT.'system/configs.inc.php';
if($configs['debug']){
	error_reporting(E_ALL ^E_NOTICE);
}else{
	error_reporting(0);
}

$installed_file = PHPDISK_ROOT.'./system/install.lock';
if(!file_exists($installed_file)){
	header("Location: ./install/index.php");
}

$charset = $configs['charset'];
header("Content-Type: text/html; charset=$charset");
require_once PHPDISK_ROOT.'./includes/mysql.class.php';
require_once PHPDISK_ROOT.'./includes/global.func.php';
require_once PHPDISK_ROOT.'./includes/cache.func.php';
require_once PHPDISK_ROOT.'./includes/plugin.func.php';
require_once PHPDISK_ROOT.'./includes/file.func.php';
require_once PHPDISK_ROOT.'./includes/ftp.func.php';
require_once PHPDISK_ROOT.'./phpdisk_version.php';


$db = new cls_mysql;
$db->connect($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['dbname'],$configs['pconnect']);
unset($configs['dbhost'],$configs['dbuser'],$configs['dbpasswd'],$configs['pconnect'],$configs['charset']);

$tpf = $configs['tpf'];

$rs = $db->fetch_one_array("select tpl_name from {$tpf}templates where tpl_type='user' and actived=1");
$tpl_name = $rs['tpl_name'] ? $rs['tpl_name'] : 'default';
$rs = $db->fetch_one_array("select tpl_name from {$tpf}templates where tpl_type='admin' and actived=1");
$admin_tpl_name = $rs['tpl_name'] ? $rs['tpl_name'] : 'admin';
$rs = $db->fetch_one_array("select lang_name from {$tpf}langs where actived=1");
$lang_name = $rs['lang_name'] ? $rs['lang_name'] : 'zh-cn';
unset($rs);
define('TPL_NAME',$tpl_name);
define('ADMIN_TPL_NAME',$admin_tpl_name);
define('LANG_DIR',PHPDISK_ROOT.'./languages/'.$lang_name.'/');
unset($tpl_name,$admin_tpl_name,$lang_name);

$tpl_dir = 'templates/'.TPL_NAME;
$admin_tpl_dir = 'templates/'.ADMIN_TPL_NAME;

require_once lang('common');

load_active_plugins();

if(@get_magic_quotes_gpc()){
    $_GET = stripslashes_array($_GET);
    $_POST = stripslashes_array($_POST);
    $_COOKIE = stripslashes_array($_COOKIE);
}

$setting_file = PHPDISK_ROOT.'system/settings.inc.php';
file_exists($setting_file) ? require_once $setting_file : settings_cache();
$group_settings_file = PHPDISK_ROOT.'system/group_settings.inc.php';
file_exists($group_settings_file) ? require_once $group_settings_file : group_settings_cache();
$stats_file = PHPDISK_ROOT.'system/stats.inc.php';
file_exists($stats_file) ? require_once $stats_file : stats_cache();

if(display_plugin('api','open_uc_plugin',$settings['connect_uc'],0)){
	$uc_conf = PD_PLUGINS_DIR.'api/uc_configs.inc.php';
	file_exists($uc_conf) ? require_once $uc_conf : exit($pub_lang['not_uc_conf'].$uc_conf);
	$uc_client = PD_PLUGINS_DIR.'api/uc_client/client.php';
	file_exists($uc_client) ? require_once $uc_client : exit($pub_lang['not_uc_client'].$uc_client);
}
if(!function_exists('urr')){
	function urr($str,$vars){
		return $vars ? $str.'.php?'.$vars : $str.'.php';
	}
}
if(getenv('HTTP_CLIENT_IP') && strcasecmp(getenv('HTTP_CLIENT_IP'), 'unknown')) {
	$onlineip = getenv('HTTP_CLIENT_IP');
} elseif(getenv('HTTP_X_FORWARDED_FOR') && strcasecmp(getenv('HTTP_X_FORWARDED_FOR'), 'unknown')) {
	$onlineip = getenv('HTTP_X_FORWARDED_FOR');
} elseif(getenv('REMOTE_ADDR') && strcasecmp(getenv('REMOTE_ADDR'), 'unknown')) {
	$onlineip = getenv('REMOTE_ADDR');
} elseif(isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] && strcasecmp($_SERVER['REMOTE_ADDR'], 'unknown')) {
	$onlineip = $_SERVER['REMOTE_ADDR'];
}
$onlineip = addslashes($onlineip);
@preg_match("/[\d\.]{7,15}/", $onlineip, $onlineipmatches);
$onlineip = $onlineipmatches[0] ? $onlineipmatches[0] : 'unknown';
unset($onlineipmatches);

$pg = (int)gpc('pg','G',0);
if(!$pg){
	$pg = 1;	
}
$perpage = $settings['perpage'];

if ($settings['gzipcompress'] && function_exists('ob_gzhandler')) {
	@ob_start('ob_gzhandler');
	$gzip_info = 'Enabled';
} else {
	ob_start();
	$gzip_info = 'Disabled';
}
$sysmsg = array();
$error = false;
$item = trim(gpc('item','GP',''));
$app = trim(gpc('app','GP',''));
$action = trim(gpc('action','GP',''));
$task = trim(gpc('task','GP',''));
$p_formhash = trim(gpc('formhash','P',''));

list($pd_uid,$pd_gid,$pd_username,$pd_pwd,$pd_email) = gpc('phpdisk_info','C','') ? explode("\t", pd_encode(gpc('phpdisk_info','C',''), 'DECODE')) : array('', '', '','','');
$pd_uid = (int)$pd_uid;
$pd_pwd = addslashes($pd_pwd);

if(!$pd_uid || !$pd_pwd){
	$pd_uid = 0;
}else{

	$userinfo = $db->fetch_one_array("SELECT userid,u.gid,username,password,email,group_name FROM {$tpf}users u,{$tpf}groups g WHERE userid='$pd_uid' and password='$pd_pwd' and u.gid=g.gid limit 1");
	if($userinfo){
		$pd_username = $userinfo['username'];
		$pd_email = $userinfo['email'];
		$pd_gid = $userinfo['gid']; 
		$pd_group_name = $userinfo['group_name'];
	}else{
		$pd_uid = 0;
		$pd_pwd = '';
		pd_setcookie('phpdisk_info', '');
	}
	
}
unset($userinfo);
$formhash = formhash();
?>