<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: global.func.php 393 2010-07-31 10:06:17Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK')) {
	exit('[PHPDisk] Access Denied');
}

function template_echo($tpl,$tpl_dir,$app='',$is_admin_tpl=0){
	global $db,$tpf,$timestamp;
	if($app){
		$tpl_cache_dir = PHPDISK_ROOT."system/plugins/$app/";
		$tpl_src_dir = PHPDISK_ROOT."plugins/$app/";
	}else{
		$tpl_cache_dir = PHPDISK_ROOT."system/{$tpl_dir}/";
		$tpl_src_dir = PHPDISK_ROOT."templates/{$tpl_dir}/";
		$tpl_default_dir = PHPDISK_ROOT."templates/default/";
		$tpl_admin_dir = PHPDISK_ROOT."templates/admin/";
	}
	if(!is_dir($tpl_cache_dir)){
		@mkdir($tpl_cache_dir,0777);
		write_file($tpl_cache_dir.'index.htm','PHPDisk');
	}
	$tpl_cache_file = $tpl_cache_dir.$tpl.".tpl.php";
	$tpl_src_file = $tpl_src_dir.$tpl.".tpl.html";
	if(!$app){
		if($is_admin_tpl && !file_exists($tpl_src_file)){
			$tpl_src_file = $tpl_admin_dir.$tpl.".tpl.html";
		}elseif(!file_exists($tpl_src_file)){
			$tpl_src_file = $tpl_default_dir.$tpl.".tpl.html";
		}
	}
	if(@filemtime($tpl_cache_file) < @filemtime($tpl_src_file)){
		write_file($tpl_cache_file,template_parse($tpl_src_file));
		template_echo($tpl,$tpl_dir);
	}
	return $tpl_cache_file;
}

function template_parse($tpl){
	if(!file_exists($tpl)){
		exit('Template '.$tpl.' did not exists!');
	}
	$str = read_file($tpl);
	$str = preg_replace("/\<\!\-\-\#(.+?)\#\-\-\>/si","<?php \\1 ?>", $str);
	$str = preg_replace("/\{([A-Z_]+)\}/","<?=\\1?>",$str);
	$str = preg_replace("/\{(\\\$[a-z0-9_\'\"\[\]]+)\}/si", "<?=\\1?>", $str);
	$str = preg_replace("/\{\<\?\=(\\\$[a-z0-9_\'\"\[\]]+)\?\>\}/si","{\\1}",$str);
	$str = str_replace(array('{#','#}'),array('<?=','?>'),$str);

	$prefix = "<?php ".LF;
	$prefix .= "// This is PHPDISK auto-generated file. Do NOT modify me.".LF.LF;
	$prefix .= "if(!defined('IN_PHPDISK'))".LF;
	$prefix .= "\texit('[PHPDisk] Access Denied');".LF;
	$prefix .= "?>".LF;

	return $prefix.$str;
}
function convert_str($in,$out,$str){
	if(function_exists("iconv")){
		$str = iconv($in,$out,$str);
	}elseif(function_exists("mb_convert_encoding")){
		$str = mb_convert_encoding($str,$out,$in);
	}
	return $str;
}
function is_utf8(){
	global $charset;
	return (strtolower($charset) == 'utf-8') ? true : false;
}
function lang($lang_name){
	$file = LANG_DIR.$lang_name.'.lang.php';
	if(!file_exists($file)){
		exit("Language pack [$lang_name] does not exist!");
	}else{
		return $file;
	}
}
function get_ids_arr($arr,$msg,$str_in_db=0){
	global $db;
	$error = 0;
	if(!count($arr)){
		$error = 1;
		$strs = $msg;
	}else{
		for($i=0;$i<count($arr);$i++){
			$strs .= $str_in_db ? $db->escape($arr[$i])."," : "'".$db->escape($arr[$i])."',";
		}
		$strs = substr($strs,0,-1);
	}
	return array($error,$strs);
}
function delete_phpdisk_file($sql){
	global $db,$tpf,$settings;
	$q = $db->query($sql);
	while($rs = $db->fetch_array($q)){
		$file_ext = get_real_ext($rs['file_extension']);
		$rs2 = $db->fetch_one_array("select count(*) as total from {$tpf}files where file_real_name='{$rs['file_real_name']}' and file_store_path='{$rs['file_store_path']}'");
		if($rs2['total']==1){
			if(display_plugin('multi_server','open_multi_server_plugin',$settings['open_multi_server'],0) && $rs['server_id']>1){
				if($rs['store_old']){
					$rs3 = $db->fetch_one_array("select * from {$tpf}servers where server_id='{$rs['server_id']}' limit 1");
					if($rs3){
						$ftp_res = pftp_connnect($rs3['ftp_host'],$rs3['ftp_user'],$rs3['ftp_pass'],$rs3['ftp_port'],'/',$rs3['ftp_ssl'],$rs3['ftp_pasv']);
						$arr = explode('/',$rs3['ftp_path']);
						if(count($arr)){
							for($i=0;$i<count($arr);$i++){
								if(trim($arr[$i])) pftp_chdir($ftp_res,$arr[$i]);
							}
						}
						pftp_delete($ftp_res,$rs['file_store_path'].'/'.$rs['file_real_name']);
						pftp_delete($ftp_res,$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb');
						pftp_close($ftp_res);
					}
					unset($rs3);
				}else{
					$rs3 = $db->fetch_one_array("select * from {$tpf}servers where server_id='{$rs['server_id']}' limit 1");
					if($rs3){
						$ftp_res = pftp_connnect($rs3['ftp_host'],$rs3['ftp_user'],$rs3['ftp_pass'],$rs3['ftp_port'],'/',$rs3['ftp_ssl'],$rs3['ftp_pasv']);
						$arr = explode('/',$rs3['ftp_path']);
						if(count($arr)){
							for($i=0;$i<count($arr);$i++){
								if(trim($arr[$i])) pftp_chdir($ftp_res,$arr[$i]);
							}
						}
						pftp_delete($ftp_res,$rs['file_store_path'].'/'.$rs['file_real_name'].$file_ext);
						pftp_delete($ftp_res,$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb'.$file_ext);
						pftp_close($ftp_res);
					}
					unset($rs3);
				}	
			}else{
				if($rs['store_old']){
					@unlink(PHPDISK_ROOT.$settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name']);
					@unlink(PHPDISK_ROOT.$settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb');
				}else{
					@unlink(PHPDISK_ROOT.$settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name'].$file_ext);
					@unlink(PHPDISK_ROOT.$settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb'.$file_ext);
				}
			}
		}	
		unset($rs2);
	}
	$db->free($q);
	unset($rs);
}
function syn_folder_size(){
	global $db,$tpf,$pd_uid;

	$q = $db->query("select * from {$tpf}folders where userid='$pd_uid' and in_recycle=0 order by folder_id asc");
	while($rs = $db->fetch_array($q)){
		if($rs['folder_id']){
			$total_size = @$db->result_first("select sum(file_size) from {$tpf}files where folder_id='{$rs['folder_id']}' and in_recycle=0 and userid='$pd_uid'");
			$db->query_unbuffered("update {$tpf}folders set folder_size='$total_size' where folder_id='{$rs['folder_id']}' and in_recycle=0 and  userid='$pd_uid'");
		}
	}
	$db->free($q);
	unset($rs);
}
function get_file_thumb($rs){
	global $db,$tpf,$settings;
	if(display_plugin('multi_server','open_multi_server_plugin',$settings['open_multi_server'],0) && $rs['server_id'] >1){
		$rs2 = $db->fetch_one_array("select * from {$tpf}servers where server_id='{$rs['server_id']}' limit 1");
		if($rs2){
			if($rs['is_image']){
				if($rs['store_old']){
					$file_thumb = $rs2['server_host'].$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb';
				}else{
					$file_thumb = $rs2['server_host'].$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb.'.$rs['file_extension'];
				}
			}
		}
		unset($rs2);
	}else{
		if($rs['is_image']){
			if($rs['store_old']){
				$file_thumb = $settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb';
			}else{
				$file_thumb = $settings['file_path'].'/'.$rs['file_store_path'].'/'.$rs['file_real_name'].'_thumb.'.$rs['file_extension'];
			}
		}
	}
	return $file_thumb;
}
function wipe_replace($str) {
	return str_replace(array( "\n", "\r", '..'), array('', '', ''), $str);
}

function word_style($i,$type ='font'){
	switch($i){
		case 500:
			$f_px = "25px";
			$c_col = '#ff6600';
		break;
		case 300:
			$f_px = "20px";
			$c_col = '#ff5500';
		break;
		case 100:
			$f_px = "18px";
			$c_col = '#003366';
		break;
		case 50:
			$f_px = "14px";
			$c_col = '#003366';
		break;
		default:
			$f_px = "12px";
			$c_col = '#666666';
	}
	return ($type =='font') ? $f_px : $c_col;
}
function short_date($str){
	return date($str);
}
function create_store_dir(){
	global $settings;
	$store_dir = PHPDISK_ROOT.$settings['file_path'];
	$y_dir = $store_dir.'/'.short_date("Y").'/';
	$m_dir = $store_dir.'/'.short_date("Y").'/'.short_date("m").'/';
	$d_dir = $store_dir.'/'.short_date("Y").'/'.short_date("m").'/'.short_date("d").'/';
	if(!is_dir($y_dir)){
		mkdir($y_dir ,0777);
		write_file($y_dir.'index.htm','PHPDisk');
	}
	if(!is_dir($m_dir)){
		mkdir($m_dir ,0777);
		write_file($m_dir.'index.htm','PHPDisk');
	}
	if(!is_dir($d_dir)){
		mkdir($d_dir ,0777);
		write_file($d_dir.'index.htm','PHPDisk');
	}
	return true;
}
function page_end_time(){
	global $ps_time,$db,$gzip_info;
	$mtime = explode(' ', microtime());
	$totaltime = number_format(($mtime[1] + $mtime[0] - $ps_time), 6);
	return 'Processed in '.$totaltime.' second(s), '.$db->querycount.' queries, Gzip '.$gzip_info;
}

function get_real_ext($file_extension){
	global $settings;
	if($file_extension){
		$exts = explode(',',$settings['filter_extension']);
		if(in_array($file_extension,$exts)){
			$file_ext = '.'.$file_extension.'.txt';
		}else{
			$file_ext = '.'.$file_extension;
		}
	}else{
		$file_ext = '.txt';
	}
	return $file_ext;
}

function replace_inject_str($str){
	$bad_chars = array("\\","'",'"','/','*',',','<','>',"\r","\t","\n",'$','(',')','%','?',';','^','#',':','&');
	return str_replace($bad_chars,'',$str);
}
function can_true_link($file_extension){
	global $settings;
	$arr = explode(',',$settings['true_link_extension']);
	return ($settings['true_link'] && in_array($file_extension,$arr)) ? true : false;
}
function make_tags($tags,$tag_arr,$file_id){
	global $db,$tpf,$timestamp,$pd_uid;
	if($tags){
		$tags_str = '';
		for($i=0;$i<count($tag_arr);$i++){
			if($tag_arr[$i]){
				$tags_str .= "'{$tag_arr[$i]}',";
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}file2tag where tag_name='{$tag_arr[$i]}' and file_id='{$file_id}'");
				if(!$rs['total']){
					$ins = array(
						'tag_name' => $tag_arr[$i],
						'file_id' => $file_id,
					);
					$db->query_unbuffered("insert into {$tpf}file2tag set ".$db->sql_array($ins).";");
				}
				unset($rs);
			}
		}
		$tags_str = (substr($tags_str,-1) ==',') ? substr($tags_str,0,-1) : $tags_str;
		$db->query_unbuffered("update {$tpf}tags set tag_count=tag_count-1 where tag_name in (select tag_name from {$tpf}file2tag where file_id='$file_id')");
		$db->query_unbuffered("delete from {$tpf}file2tag where file_id='$file_id' and tag_name not in ($tags_str)");
		
		$tagdb = explode(',',$tags);
		for($i=0; $i<count($tagdb); $i++){
			$tagdb[$i] = trim($tagdb[$i]);
			if($tagdb[$i]){
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}tags where tag_name='{$tagdb[$i]}'");
				if(!$rs['total']){
					$ins = array(
						'tag_name' => $db->escape($tagdb[$i]),
						'tag_count' => 1,
					);
					$db->query_unbuffered("insert into {$tpf}tags set ".$db->sql_array($ins).";");							
				}
				unset($rs);
				$db->query_unbuffered("update {$tpf}tags set tag_count=(select count(*) from {$tpf}file2tag where tag_name='{$tagdb[$i]}') where tag_name='{$tagdb[$i]}'");
			}
		}

	}else{
		$q = $db->query("select * from {$tpf}file2tag where file_id='$file_id'");
		while($rs = $db->fetch_array($q)){
			$tags_str .= "'{$rs['tag_name']}',";
		}
		$db->free($q);
		unset($rs);
		$tags_str = (substr($tags_str,-1) ==',') ? substr($tags_str,0,-1) : $tags_str;
		if($tags_str){
			$db->query_unbuffered("update {$tpf}tags set tag_count=tag_count-1 where tag_name in ($tags_str)");
			$db->query_unbuffered("delete from {$tpf}file2tag where file_id='$file_id'");
		}
	}
}
function phpdisk_user(){
	global $pd_uid,$pd_pwd;
	if(!$pd_uid || !$pd_pwd){
		header("Location: ".urr("account","action=login&ref=".$_SERVER['REQUEST_URI']));
	}
}
function phpdisk_admin(){
	global $db,$pd_uid,$pd_pwd,$pd_gid,$timestamp,$tpf,$_SESSION;
	$admin_not_login =0;
	$rs = $db->fetch_one_array("select * from {$tpf}adminsession where userid='$pd_uid' limit 1");
	if(!$_SESSION['pd_sid'] || $rs['hashcode'] != $_SESSION['pd_sid']){
		$admin_not_login =1;
	}
	unset($rs);
	if(!$pd_uid || !$pd_pwd || $pd_gid !=1 || $admin_not_login){
		header("Location: ".urr("account","action=adminlogin&ref=".$_SERVER['REQUEST_URI']));
	}
}
function flashget_encode($t_url,$uid){
	$prefix = "Flashget://";
	$FlashgetURL = $prefix.base64_encode("[FLASHGET]".$t_url."[FLASHGET]")."&".$uid;
	return $FlashgetURL;
}

function thunder_encode($url){
	$thunderPrefix = "AA";
	$thunderPosix = "ZZ";
	$thunderTitle = "thunder://";
	$thunderUrl = $thunderTitle.base64_encode($thunderPrefix.$url.$thunderPosix);
	return $thunderUrl;
}

function checklength($str,$min,$max){
	if(!$str || strlen($str) > $max || strlen($str) < $min){
		return true;
	}
}
function ifselected($int1,$int2,$type = 'int'){
	if($type == 'int'){
		if(intval($int1) == intval($int2)){
			return " selected";
		}
	}elseif($type == 'str'){
		if(strval($int1) == strval($int2)){
			return " selected";
		}
	}
}
function ifchecked($int1,$int2,$type = 'int'){
	if($type == 'int'){
		if(intval($int1) == intval($int2)){
			return " checked";
		}
	}elseif($type == 'str'){
		if(strval($int1) == strval($int2)){
			return " checked";
		}
	}
}
function replace_js($str){
	return preg_replace("'<script[^>]*?>(.*?)</script>'si","[script]\\1[/script]",$str);
}
function custom_time($format, $time){
	global $pub_lang,$timestamp;
	$s = $timestamp - $time;
	if($s < 0){
		return $pub_lang['custom_time_0'];
	}
	if($s < 60){
		return $s.$pub_lang['custom_time_1'];
	}
	$m = $s / 60;
	if($m < 60){
		return floor($m).$pub_lang['custom_time_2'];
	}
	$h = $m / 60;
	if($h < 24){
		return floor($h).$pub_lang['custom_time_3'];
	}
	$d = $h / 24;
	if($d < 2){
		return $pub_lang['custom_time_4'].date("H:i", $time);
	}
	if($d <3){
		return $pub_lang['custom_time_5'].date("H:i", $time);
	}
	if($d <= 30){
		return floor($d).$pub_lang['custom_time_6'];
	}
	return date($format, $time);
}
function file_icon($ext,$fd = 'filetype',$align='absmiddle'){
	$icon = PHPDISK_ROOT."images/{$fd}/".$ext.".gif";
	if(file_exists($icon)){
		$img = "<img src='images/{$fd}/{$ext}.gif' align='{$align}' border='0' />";
	}else{
		$img = "<img src='images/{$fd}/file.gif' align='{$align}' border='0' />";
	}
	return $img;
}
function get_byte_value($v){
	$v = trim($v);
	$l = strtolower($v[strlen($v) - 1]);
	switch($l){
	  case 'g':
		$v *= 1024;
	
	  case 'm':
		$v *= 1024;
	
	  case 'k':
		$v *= 1024;
	}
	return $v;
}

function mime_type( $ext ){
	$mime = array(
		'avi'  => 'video/x-msvideo',
		'bmp'  => 'image/bmp',
		'css'  => 'text/css',
		'js'   => 'application/x-javascript js',
		'doc'  => 'application/msword',
		'gif'  => 'image/gif',
		'htm'  => 'text/html',
		'html' => 'text/html',
		'jpg'  => 'image/jpeg',
		'jpeg' => 'image/jpeg',
		'mov'  => 'video/quicktime',
		'mpeg' => 'video/mpeg',
		'mp3'  => 'audio/mpeg mpga mp2 mp3',
		'pdf'  => 'application/pdf',
		'php'  => 'text/html',
		'png'  => 'image/png',
		'qt'   => 'video/quicktime',
		'rar'  => 'application/x-rar',
		'swf'  => 'application/x-shockwave-flash swf',
		'txt'  => 'text/plain',
		'wmv'  => 'video/x-ms-wmv',
		'xml'  => 'text/xml',
		'xsl'  => 'text/xml',
		'xls'  => 'application/msexcel x-excel',
		'zip'  => 'application/zip x-zip',
		'torrent' => 'application/x-bittorrent',
		
	);
	return isset($mime[$ext]) ? $mime[$ext] : 'application/octet-stream';
}
function tb_redirect($ref,$timeout=3000){
	$str .= "<script>".LF;
	$str .= "setTimeout(function(){self.parent.tb_remove();},$timeout);".LF;
	$str .= "self.parent.document.location.href='$ref';".LF;
	$str .= "</script>".LF;
	echo $str;
}

function redirect($url,$str,$timeout = 2000,$target = ''){
	global $pub_lang,$lang;
	$lang = array_merge($pub_lang,$lang);
	
	if($timeout ==0){
		header("Location:$url");
	}else{
		$msg = '';
		if(is_array($str)){
			for($i=0;$i<count($str);$i++){
				$msg .= "<li>·".$str[$i]."</li>".LF;
			}
		}else{
			$msg = $str;
		}	
		require_once template_echo('information',TPL_NAME);
		$rtn = "<script>".LF;
		$rtn .= "<!--".LF;
		$rtn .= "function redirect() {".LF;
		if($target =='top'){
			$rtn .= "	self.parent.location.href = '$url';".LF;
		}else{
			$rtn .= "	document.location.href = '$url';".LF;
		}
		$rtn .= "}".LF;
		$rtn .= "setTimeout('redirect();', $timeout);".LF;
		$rtn .= "-->".LF;
		$rtn .= "</script>".LF;
		echo $rtn;
	}
}
function show_box_msg($str){
	echo '<div class="tb_box_msg"><img src="images/light.gif" border="0" align="absmiddle">&nbsp;'.$str.'</div>';
}
function is_bad_chars($str){
	$bad_chars = array("\\",' ',"'",'"','/','*',',','<','>',"\r","\t","\n",'$','(',')','%','+','?',';','^','#',':','　','`','=','|','-');
	foreach($bad_chars as $value){
		if (strpos($str,$value) !== false){
			return true;
		}
	}
}
function get_extension($name){
	return strtolower(trim(strrchr($name, '.'), '.'));
}
function formhash(){
	global $pd_uid,$pd_pwd, $timestamp;
	return substr(md5(substr($timestamp, 0, -7).$pd_uid.$pd_pwd), 8, 8);
}
function encode_pwd($str){
	global $settings;
	$len = trim($str) ? strlen($str) : 6;
	if($settings['online_demo']){
		$rtn = str_repeat('*',$len);
	}else{
		if($len <=4){
			$rtn = str_repeat('*',$len);
		}elseif($len <=10){
			$rtn = str_repeat('*',$len-4);
			$rtn .= substr($str,-4);
		}else{
			$rtn = str_repeat('*',$len-6);
			$rtn .= substr($str,-6);
		}
	}
	return $rtn; 
}
function random($length){ 
	$seed = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"; 
	$str = "";
	while(strlen($str) < $length){ 
		  $str .= substr($seed,(mt_rand() % strlen($seed)),1); 
	} 
	return $str; 
} 

function stripslashes_array(&$array) {
	if(is_array($array)){
		foreach($array as $k => $v) {
			$array[$k] = stripslashes_array($v);
		}
	}elseif(is_string($array)){
		$array = stripslashes($array);
	}
	return $array;
}

function get_size($s,$u='B',$p=1){
	$us = array('B'=>'K','K'=>'M','M'=>'G','G'=>'T');
	return (($u!=='B')&&(!isset($us[$u]))||($s<1024))?(number_format($s,$p)." $u"):(get_size($s/1024,$us[$u],$p));
}

function checkemail($email) {
	if((strlen($email) > 6) && preg_match("/^[\w\-\.]+@[\w\-\.]+(\.\w+)+$/", $email)){
		return true;
	}else{
		return false;
	}
}

function gpc($name,$w = 'GPC',$default = ''){ 
	$i = 0; 
	for($i = 0; $i < strlen($w); $i++) { 
		if($w[$i] == 'G' && isset($_GET[$name])) return $_GET[$name]; 
		if($w[$i] == 'P' && isset($_POST[$name])) return $_POST[$name]; 
		if($w[$i] == 'C' && isset($_COOKIE[$name])) return $_COOKIE[$name]; 
	} 
	return $default; 
}
function pd_setcookie($var, $value, $expires = 0,$cookiepath = '/', $cookiedomain = '') {
	global $timestamp, $_SERVER;
	setcookie($var, $value,$expires ? ($timestamp + $expires) : 0,$cookiepath,$cookiedomain, $_SERVER['SERVER_PORT'] == 443 ? 1 : 0);
}

function pd_encode($txt, $operation = 'ENCODE',$key = 'PHPDisk=Rc9o'){
	global $settings;
	$key = $settings['encrypt_key'] ? $settings['encrypt_key'] : $key;
	if($operation == 'DECODE'){
		$txt = encrypt_key(base64_decode($txt), $key);
		$tmp = '';
		for ($i = 0; $i < strlen($txt); $i++) {
			$tmp .= $txt[$i] ^ $txt[++$i];
		}
		return $tmp;
	}else{
		srand((double)microtime() * 1000000);
		$encrypt_key = md5(rand(0, 32000));
		$ctr = 0;
		$tmp = '';
		for($i = 0; $i < strlen($txt); $i++) {
			$ctr = $ctr == strlen($encrypt_key) ? 0 : $ctr;
			$tmp .= $encrypt_key[$ctr].($txt[$i] ^ $encrypt_key[$ctr++]);
		}
		return base64_encode(encrypt_key($tmp, $key));
	}
}
function encrypt_key($txt, $key) {
	$md5_key = md5($key);
	$ctr = 0;
	$tmp = '';
	for($i = 0; $i < strlen($txt); $i++) {
		$ctr = $ctr == strlen($md5_key) ? 0 : $ctr;
		$tmp .= $txt[$i] ^ $md5_key[$ctr++];
	}
	return $tmp;
}

function cutstr($string, $length, $dot = '...',$charset='utf-8') {
	if(strlen($string) <= $length) {
		return $string;
	}
	$string = str_replace(array('&amp;', '&quot;', '&lt;', '&gt;'), array('&', '"', '<', '>'), $string);
	$strcut = '';
	if(strtolower($charset) == 'utf-8') {

		$n = $tn = $noc = 0;
		while($n < strlen($string)) {

			$t = ord($string[$n]);
			if($t == 9 || $t == 10 || (32 <= $t && $t <= 126)) {
				$tn = 1; $n++; $noc++;
			} elseif(194 <= $t && $t <= 223) {
				$tn = 2; $n += 2; $noc += 2;
			} elseif(224 <= $t && $t < 239) {
				$tn = 3; $n += 3; $noc += 2;
			} elseif(240 <= $t && $t <= 247) {
				$tn = 4; $n += 4; $noc += 2;
			} elseif(248 <= $t && $t <= 251) {
				$tn = 5; $n += 5; $noc += 2;
			} elseif($t == 252 || $t == 253) {
				$tn = 6; $n += 6; $noc += 2;
			} else {
				$n++;
			}

			if($noc >= $length) {
				break;
			}

		}
		if($noc > $length) {
			$n -= $tn;
		}

		$strcut = substr($string, 0, $n);

	} else {
		for($i = 0; $i < $length - strlen($dot) - 1; $i++) {
			$strcut .= ord($string[$i]) > 127 ? $string[$i].$string[++$i] : $string[$i];
		}
	}

	$strcut = str_replace(array('&', '"', '<', '>'), array('&amp;', '&quot;', '&lt;', '&gt;'), $strcut);

	return $strcut.$dot;
}

function multi($total, $perpage, $curpage, $mpurl) {
	$multipage = '';
	$mpurl .= strpos($mpurl, '?') ? '&amp;' : '?';
	if($total > $perpage) {
		$pg = 10;
		$offset = 5;
		$pgs = @ceil($total / $perpage);
		if($pg > $pgs) {
			$from = 1;
			$to = $pgs;
		} else {
			$from = $curpage - $offset;
			$to = $curpage + $pg - $offset - 1;
			if($from < 1) {
				$to = $curpage + 1 - $from;
				$from = 1;
				if(($to - $from) < $pg && ($to - $from) < $pgs) {
					$to = $pg;
				}
			} elseif($to > $pgs) {
				$from = $curpage - $pgs + $to;
				$to = $pgs;
				if(($to - $from) < $pg && ($to - $from) < $pgs) {
					$from = $pgs - $pg + 1;
				}
			}
		}

		$multipage = ($curpage - $offset > 1 && $pgs > $pg ? '<a href="'.$mpurl.'pg=1" class="p_redirect">&laquo;</a>' : '').($curpage > 1 ? '<a href="'.$mpurl.'pg='.($curpage - 1).'" class="p_redirect">&#8249;</a>' : '');
		for($i = $from; $i <= $to; $i++) {
			$multipage .= $i == $curpage ? '<span class="p_curpage">'.$i.'</span>' : '<a href="'.$mpurl.'pg='.$i.'" class="p_num">'.$i.'</a>';
		}
		$multipage .= ($curpage < $pgs ? '<a href="'.$mpurl.'pg='.($curpage + 1).'" class="p_redirect">&#8250;</a>' : '').($to < $pgs ? '<a href="'.$mpurl.'pg='.$pgs.'" class="p_redirect">&raquo;</a>' : '');
		$multipage = $multipage ? '<div class="p_bar"><span class="p_info">Total:&nbsp;<b>'.$total.'</b>&nbsp;</span>'.$multipage.'</div>' : '';
	}
	return $multipage;
}

?>