<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: public.inc.php 391 2010-07-31 04:05:52Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_MYDISK')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_user();
define('SCRIPT_NAME',$item);

require_once lang(SCRIPT_NAME);

$lang = array_merge($pub_lang,$lang);

$cache_file = PHPDISK_ROOT."system/cache/$pd_uid/my_folders_4.inc.php";
file_exists($cache_file) ? require_once $cache_file : $option_folder_4 = get_option_folders(4,0);

$cache_file = PHPDISK_ROOT."system/cache/$pd_uid/pub_menu_option.inc.php";
file_exists($cache_file) ? require_once $cache_file : $pub_menu_option = get_option_public_folder(0);

$rs = $db->fetch_one_array("select user_store_space from {$tpf}users where userid='$pd_uid'");
if($rs['user_store_space'] ==0){
	$max_storage = $group_settings[$pd_gid]['max_storage']==0 ? $lang['no_limit'] : $group_settings[$pd_gid]['max_storage'];
}else{
	$max_storage = $rs['user_store_space'];
}
unset($rs);

$file_size_total = (int)@$db->result_first("select sum(file_size) from {$tpf}files where userid='$pd_uid'");
$now_space = get_size($file_size_total);
$file_size_total = ($rs['file_size_total'] > get_byte_value($max_storage)) ? get_byte_value($max_storage) : $rs['file_size_total'];
$disk_fill = $max_storage ? @round($file_size_total/get_byte_value($max_storage),1)*120 : 0;
$disk_percent = $max_storage ? @round($file_size_total/get_byte_value($max_storage),3)*100 : 0;
$disk_remain = 100-$disk_percent;
$disk_space = $max_storage ? get_size(get_byte_value($max_storage)-$file_size_total) : $lang['no_limit'];

switch($action){
	case 'index':
	case 'detail':

		if($task == 'to_folder'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			$dest_folder = gpc('dest_folder','P',0);

			$ids_arr = get_ids_arr($file_ids,$lang['please_select_operation_files']);
			if($ids_arr[0]){
				$error = true;
				$sysmsg[] = $ids_arr[1];
			}else{
				$file_str = $ids_arr[1];
			}

			if($dest_folder == -1){
				$error = true;
				$sysmsg[] = $lang['please_select_dest_folder'];
			}else{
				$dest_folder = (int)$dest_folder;
			}
			
			if(!$error){
				$ins = array(
					'folder_id' => $dest_folder,
					'is_public' => 0,
					'cate_id' => 0,
					'subcate_id' => 0,
				);
				$db->query_unbuffered("update {$tpf}files set ".$db->sql_array($ins)." where file_id in ($file_str) and userid='$pd_uid'");
				syn_folder_size();
				folders_menu_cache(1);

				$sysmsg[] = $lang['move_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
				
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}
		
		}elseif($task == 'to_public'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			$public_cate = gpc('public_cate','P',0);
			
			$ids_arr = get_ids_arr($file_ids,$lang['please_select_operation_files']);
			if($ids_arr[0]){
				$error = true;
				$sysmsg[] = $ids_arr[1];
			}else{
				$file_str = $ids_arr[1];
			}

			if($public_cate == -1){
				$error = true;
				$sysmsg[] = $lang['please_select_dest_folder'];
			}else{
				$public_cate = (int)$public_cate;
			}
			
			if(!$error){
				$db->query_unbuffered("update {$tpf}files set is_public='1',cate_id='$public_cate',in_recycle=0 where file_id in ($file_str)");
				syn_folder_size();
				folders_menu_cache(1);
				public_menu_cache(1);

				$sysmsg[] = $lang['move_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
				
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}

		}elseif($task == 'file_delete'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			
			$ids_arr = get_ids_arr($file_ids,$lang['please_select_operation_files']);
			if($ids_arr[0]){
				$error = true;
				$sysmsg[] = $ids_arr[1];
			}else{
				$file_str = $ids_arr[1];
			}
			
			if(!$error){
				delete_phpdisk_file("select * from {$tpf}files where file_id in ($file_str) and is_public=1 and userid='$pd_uid'");	
				$db->query_unbuffered("delete from {$tpf}files where file_id in ($file_str) and is_public=1 and userid='$pd_uid'");
				syn_folder_size();
				public_menu_cache(1);

				$sysmsg[] = $lang['file_delete_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
				
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}
			
		}else{
		
			delete_phpdisk_file("select * from {$tpf}files where is_public=1 and userid='$pd_uid' and cate_id=0 and subcate_id=0 and $timestamp-file_time>7*86400");	
			$db->query_unbuffered("delete from {$tpf}files where is_public=1 and userid='$pd_uid' and cate_id=0 and subcate_id=0 and $timestamp-file_time>7*86400");
			syn_folder_size();
			public_menu_cache(1);

			$cate_id = (int)gpc('cate_id','G',0);
			$pid = (int)gpc('pid','G',0);
	
			if($cate_id){
				if($pid){
					$sql_do = " {$tpf}files where cate_id='$pid' and subcate_id='$cate_id' and is_public=1 and userid='$pd_uid'";
					$cate_name = @$db->result_first("select cate_name from {$tpf}categories where cate_id='$pid'");
					$subcate_name = @$db->result_first("select cate_name from {$tpf}categories where cate_id='$cate_id'");
					$a_cate = urr("mydisk","item=public&action=index&pid=0&cate_id=$pid");
				}else{
					$sql_do = " {$tpf}files where cate_id='$cate_id' and is_public=1 and userid='$pd_uid'";
					$cate_name = @$db->result_first("select cate_name from {$tpf}categories where cate_id='$cate_id'");
				}
			}else{
				$sql_do = " {$tpf}files where cate_id='0' and is_public=1 and userid='$pd_uid'";
			}
			$rs = $db->fetch_one_array("select count(*) as total_num from {$sql_do}");
			$total_num = $rs['total_num'];
			$start_num = ($pg-1) * $perpage;
			
			$q = $db->query("select * from {$sql_do} order by file_id desc limit $start_num,$perpage");
			$files_array = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_thumb'] = get_file_thumb($rs);
				$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,35);
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = custom_time("Y-m-d",$rs['file_time']);
				$rs['a_viewfile'] = urr("viewfile","file_id={$rs['file_id']}");
				$rs['a_downfile'] = urr("downfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['a_file_modify'] = urr("mydisk","item=public&action=file_modify&file_id={$rs['file_id']}");
				$rs['a_file_delete'] = urr("mydisk","item=public&action=file_delete&file_id={$rs['file_id']}");
				$files_array[] = $rs;
			}
			$db->free($q);
			unset($rs);
			
			$page_nav = multi($total_num, $perpage, $pg, urr("mydisk","item=public&action=index&cate_id=$cate_id"));

			$subcate_id_t = $cate_id;
			$cate_id_t = $pid;
			
			$a_upload_file = urr("mydisk","item=upload&is_public=1&cate_id=$cate_id_t&subcate_id=$subcate_id_t&folder_node=$folder_node&folder_id=$folder_id&uid=$pd_uid");
			$chg_action = ($action=='detail') ? 'index' : 'detail';
			$a_list_detail = urr("mydisk","item=public&action=$chg_action&pid=$cate_id_t&cate_id=$subcate_id_t");
			
			require_once template_echo(SCRIPT_NAME,TPL_NAME);
		}
	break;
	
	case 'file_modify':
		$file_id = (int)gpc('file_id','GP',0);
		
		if($task == 'file_modify'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$ref = trim(gpc('ref','P',''));
			$file_name = trim(gpc('file_name','P',''));
			$file_description = trim(gpc('file_description','P',''));
			
			if(checklength($file_name,1,100)){
				$error = true;
				$sysmsg[] = $lang['file_min_max'];
			}
			if($file_description && checklength($file_description,1,250)){
				$error = true;
				$sysmsg[] = $lang['file_description_min_max'];
			}
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}files where userid='$pd_uid' and file_name='".$db->escape($file_name)."' and file_id<>'$file_id'");
			if($rs['total']){
				$error = true;
				$sysmsg[] = $lang['file_name_exists'];
			}
			if(!$error){
				$ins = array(
					'file_name' => $db->escape($file_name),
					'file_description' => $db->escape($file_description),
				);
				$db->query_unbuffered("update {$tpf}files set ".$db->sql_array($ins)." where file_id='{$file_id}' and userid='$pd_uid';");
				show_box_msg($lang['file_modify_success']);
				tb_redirect($ref);
			}else{
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
			}
		}else{
			$file = $db->fetch_one_array("select file_name,file_description from {$tpf}files where file_id='$file_id' and userid='$pd_uid'");
			$ref = $_SERVER['HTTP_REFERER'];
			require_once template_echo(SCRIPT_NAME,TPL_NAME);
			
		}
	break;
	
	case 'file_delete':
		$file_id = (int)gpc('file_id','GP',0);
		
		if($task =='file_delete'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$ref = trim(gpc('ref','P',''));
			
			if(!$error){
				delete_phpdisk_file("select * from {$tpf}files where file_id='$file_id' and userid='$pd_uid'");	
				$db->query_unbuffered("delete from {$tpf}files where file_id='$file_id' and userid='$pd_uid'");
				syn_folder_size();
				show_box_msg($lang['file_delete_success']);
				tb_redirect($ref);
			}else{
				redirect('javascript:history.back();',$sysmsg,0);
			}
		}else{
			$rs = $db->fetch_one_array("select file_name,file_extension from {$tpf}files where file_id='$file_id' and userid='$pd_uid'");
			$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
			$file_name = $rs['file_name'].$tmp_ext;
			$file_extension = $rs['file_extension'];
			$ref = $_SERVER['HTTP_REFERER'];
			unset($rs);
			require_once template_echo(SCRIPT_NAME,TPL_NAME);
		}
	break;
	
}
?>