<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: payment.php 391 2010-07-31 04:05:52Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

include "includes/commons.inc.php";

$in_front = true;

require_once lang('payment');

$lang = array_merge($pub_lang,$lang);
if(!display_plugin('payment','open_payment_plugin',$settings['open_payment'],0)){
	exit('ERROR: payment '.$lang['plugin_not_install']);
}

$title = $lang['pay_online'];
include PHPDISK_ROOT."./includes/header.inc.php";

switch($action){
	case 'alipay':
		include_once PD_PLUGINS_DIR."payment/alipay/alipay_notify.php";
		include_once PD_PLUGINS_DIR."payment/alipay/alipay_config.php";
		
		$alipay = new alipay_notify($partner,$security_code,$sign_type,$_input_charset,$transport);
		$verify_result = $alipay->return_verify();
		
		$out_trade_no = trim(gpc('out_trade_no','G',''));
		$total_fee = (float)gpc('total_fee','G','');  
		 
		if($verify_result) {
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$out_trade_no' and pay_method='alipay' and userid='$pd_uid'");
			if($rs['total']){
				$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
			}else{
				$ins = array(
					'pay_method' => $action,
					'userid' => $pd_uid,
					'order_number' => $db->escape($out_trade_no),
					'total_fee' => $total_fee,
					'pay_status' => 'success',
					'in_time' => $timestamp,
					'ip' => $onlineip,
				);
				$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
				$db->query_unbuffered("update {$tpf}users set wealth=wealth+$total_fee where userid='$pd_uid' limit 1");
				
				$s_title = $lang['pay_success'];
				$msg = $lang['your_order'].': '.$out_trade_no.','.$lang['pay_success'];
			}
		
		}else {
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$out_trade_no' and pay_method='alipay' and userid='$pd_uid'");
			if($rs['total']){
				$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
			}else{
				$ins = array(
					'pay_method' => $action,
					'userid' => $pd_uid,
					'order_number' => $db->escape($out_trade_no),
					'total_fee' => $total_fee,
					'pay_status' => 'fail',
					'in_time' => $timestamp,
					'ip' => $onlineip,
				);
				$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
				
				$s_title = $lang['pay_fail'];
				$msg = $lang['your_order'].': '.$out_trade_no.','.$lang['pay_fail'];
			}
		}
		require_once template_echo('pd_payment',TPL_NAME);
	break;
	
	case 'tenpay':
		include_once PD_PLUGINS_DIR."payment/tenpay/PayResponseHandler.class.php";
		
		$key = $settings['ten_key'];
		$resHandler = new PayResponseHandler();
		$resHandler->setKey($key);
		
		if($resHandler->isTenpaySign()) {
			$transaction_id = $resHandler->getParameter("transaction_id");
			$total_fee = $resHandler->getParameter("total_fee");
			$total_fee = round($total_fee/100,2);
			$pay_result = $resHandler->getParameter("pay_result");
			
			if( "0" == $pay_result ) {
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$transaction_id' and pay_method='tenpay' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => 'tenpay',
						'userid' => $pd_uid,
						'order_number' => $db->escape($transaction_id),
						'total_fee' => $total_fee,
						'pay_status' => 'success',
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					$db->query_unbuffered("update {$tpf}users set wealth=wealth+$total_fee where userid='$pd_uid' limit 1");
					
					$s_title = $lang['pay_success'];
					$msg = $lang['your_order'].': '.$transaction_id.','.$lang['pay_success'];
				}
				unset($rs);
			} else {
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$transaction_id' and pay_method='tenpay' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => 'tenpay',
						'userid' => $pd_uid,
						'order_number' => $db->escape($transaction_id),
						'total_fee' => $total_fee,
						'pay_status' => 'fail',
						'retcode' => $retcode,
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					$s_title = $lang['pay_fail'];
					$msg = $lang['your_order'].': '.$transaction_id.','.$lang['pay_fail'];
				}	
			}
		} else {
			$msg = '<span class="txtred">'.$lang['tenpay_pay_error'].'</span>';
		}
	break;	
	default:
		redirect('./','');
}
include PHPDISK_ROOT."./includes/footer.inc.php";

?>