<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: admin.inc.php 315 2010-07-03 08:16:18Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();

check_plugin_active_status($app);

require_once "{$app}.lang.php";

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'index':
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$show_order = gpc('show_order','P',array());
			$annids = gpc('annids','P',array());
			
			for($i =0;$i<count($annids);$i++){
				$db->query_unbuffered("update {$tpf}announces set show_order='".(int)$show_order[$i]."' where annid='".(int)$annids[$i]."'");
			}
			redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);
			
		}else{
			$q = $db->query("select * from {$tpf}announces order by show_order asc,annid asc");
			$announces = array();
			while($rs = $db->fetch_array($q)){
				$rs['status_text'] = $rs['is_hidden'] ? '<span class="txtblue">'.$lang['display'].'</span>' : $lang['hidden'];
				$rs['short_content'] = str_replace("\r\n",' ',cutstr(preg_replace("/<.+?>/i","",$rs['content']),45));
				$rs['content'] = preg_replace("/<.+?>/i","",str_replace('<br>',LF,$rs['content']));
				$rs['a_modify_announce'] = urr("admincp","item=plugins&app=$app&action=modify_announce&annid={$rs['annid']}");
				$rs['a_delete_announce'] = urr("admincp","item=plugins&app=$app&action=delete_announce&annid={$rs['annid']}");
				$rs['a_change_status'] = urr("admincp","item=plugins&app=$app&action=change_status&annid={$rs['annid']}");
				$announces[] = $rs;
			}
			$db->free($q);
			unset($rs);
			require_once template_echo('admin','',$app);
		}
	case 'add_announce':
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='add_announce'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$subject = trim(gpc('subject','P',''));
			$content = trim(gpc('content','P',''));
			
			if(checklength($subject,2,100)){
				$error = true;
				$sysmsg[] = $lang['subject_error'];
			}
			if(checklength($content,2,3000)){
				$error = true;
				$sysmsg[] = $lang['content_error'];
			}else{
				$content = str_replace(LF,'<br>',$content);
			}
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}announces where subject='".$db->escape($subject)."'");
			if($rs['total'] >0){
				$error = true;
				$sysmsg[] = $lang['announce_exists'];
			}
			unset($rs);
			if(!$error){
				$ins = array(
					'userid' => $pd_uid,
					'subject' => $db->escape(replace_js($subject)),
					'content' => addslashes(replace_js($content)),
					'in_time' => $timestamp,
				);
				$db->query("insert into {$tpf}announces set ".$db->sql_array($ins).";");
				redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			require_once template_echo('admin','',$app);
		}
	break;
	
	case 'modify_announce':
		$annid = (int)gpc('annid','GP',0);
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='modify_announce'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$subject = trim(gpc('subject','P',''));
			$content = trim(gpc('content','P',''));
			
			if(checklength($subject,2,100)){
				$error = true;
				$sysmsg[] = $lang['subject_error'];
			}
			if(checklength($content,2,3000)){
				$error = true;
				$sysmsg[] = $lang['content_error'];
			}else{
				$content = str_replace(LF,'<br>',$content);
			}
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}announces where subject='".$db->escape($subject)."'");
			if($rs['total'] >1){
				$error = true;
				$sysmsg[] = $lang['announce_exists'];
			}
			unset($rs);
			if(!$error){
				$ins = array(
					'subject' => $db->escape(replace_js($subject)),
					'content' => addslashes(replace_js($content)),
					'in_time' => $timestamp,
				);
				$db->query("update {$tpf}announces set ".$db->sql_array($ins)." where annid='$annid' limit 1;");
				redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$rs = $db->fetch_one_array("select * from {$tpf}announces where annid='$annid'");
			if($rs){
				$subject = $rs['subject'];
				$content = str_replace('<br>',LF,$rs['content']);
			}
			unset($rs);
			require_once template_echo('admin','',$app);
		}
	break;
	
	case 'delete_announce':
		if($settings['online_demo']){
			$sysmsg[] = $lang['you_no_power'];
			redirect("javascript:history.back();",$sysmsg);
		}else{
			$annid = (int)gpc('annid','G',0);
			$db->query_unbuffered("delete from {$tpf}announces where annid='$annid' limit 1");
			redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);	
		}	
	break;
	
	case 'change_status':
		if($settings['online_demo']){
			$sysmsg[] = $lang['you_no_power'];
			redirect("javascript:history.back();",$sysmsg);
		}else{
			$annid = (int)gpc('annid','G',0);
			$rs = $db->fetch_one_array("select is_hidden from {$tpf}announces where annid='$annid'");
			$status = $rs['is_hidden'] ? 0 : 1; 
			unset($rs);
			$db->query_unbuffered("update {$tpf}announces set is_hidden='$status' where annid='$annid'");
			redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);	
		}	
	break;
		
	default:
		redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);
}
update_action_time($app);
?>