<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: admin.inc.php 391 2010-07-31 04:05:52Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();

require_once "{$app}.lang.php";

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'add_cate':
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='add_cate'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$cate_name = trim(gpc('cate_name','P',''));
			$pid = (int)gpc('pid','P',0);
			$is_hidden = (int)gpc('is_hidden','P',0);
			
			if(checklength($cate_name,2,60)){
				$error = true;
				$sysmsg[] = $lang['cate_name_error'];
			}
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}categories where cate_name='".$db->escape($cate_name)."'");
			if($rs['total']){
				$error = true;
				$sysmsg[] = $lang['cate_name_exists'];
			}
			if(!$error){
				$ins = array(
					'cate_name' => $db->escape($cate_name),
					'pid' => $pid,
					'is_hidden' => $is_hidden,
				);	
				$db->query("insert into {$tpf}categories set ".$db->sql_array($ins).";");
				public_menu_cache(1);
				$sysmsg[] = $lang['cate_add_success'];
				redirect(urr("admincp","item=plugins&app=$app&action=category"),$sysmsg);
				
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$q = $db->query("select * from {$tpf}categories where pid=0 order by show_order asc,cate_id asc");
			$cate_arr = array();
			while($rs = $db->fetch_array($q)){
				$cate_arr[] = $rs;
			}
			$db->free($q);
			unset($rs);
			require_once template_echo('admin','',$app);
		}
	break;
	
	case 'modify_cate':
		$cate_id = (int)gpc('cate_id','GP',0);
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='modify_cate'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$cate_name = trim(gpc('cate_name','P',''));
			$pid = (int)gpc('pid','P',0);
			$is_hidden = (int)gpc('is_hidden','P',0);
			
			if(checklength($cate_name,2,60)){
				$error = true;
				$sysmsg[] = $lang['cate_name_error'];
			}
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}categories where cate_name='".$db->escape($cate_name)."' and cate_id<>'$cate_id'");
			if($rs['total']){
				$error = true;
				$sysmsg[] = $lang['cate_name_exists'];
			}
			if(!$error){
				$ins = array(
					'cate_name' => $db->escape($cate_name),
					'pid' => $pid,
					'is_hidden' => $is_hidden,
				);	
				$db->query("update {$tpf}categories set ".$db->sql_array($ins)." where cate_id='$cate_id' and cate_id<>'$pid';");
				public_menu_cache(1);
				$sysmsg[] = $lang['cate_modify_success'];
				redirect(urr("admincp","item=plugins&app=$app&action=category"),$sysmsg);
				
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$q = $db->query("select * from {$tpf}categories where pid=0 order by show_order asc,cate_id asc");
			$cate_arr = array();
			while($rs = $db->fetch_array($q)){
				$cate_arr[] = $rs;
			}
			$db->free($q);
			unset($rs);
		
			$rs = $db->fetch_one_array("select * from {$tpf}categories where cate_id='$cate_id'");
			if($rs){
				$cate_name = $rs['cate_name'];
				$pid = $rs['pid'];
				$is_hidden = $rs['is_hidden'];
			}
			unset($rs);
			require_once template_echo('admin','',$app);
		}
	break;
	
	case 'category':
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task =='update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$show_order = gpc('show_order','P',array());
			$cate_ids = gpc('cate_ids','P',array());
			$cate_names = gpc('cate_names','P',array());

			for($i =0;$i<count($cate_ids);$i++){
				$title = $db->escape(trim(replace_js($cate_names[$i])));
				if($title){
					$db->query_unbuffered("update {$tpf}categories set show_order='".(int)$show_order[$i]."',cate_name='$title' where cate_id='".(int)$cate_ids[$i]."'");
				}
			}
			public_menu_cache(1);
			redirect(urr("admincp","item=plugins&app=$app&action=category"),'',0);
			
		}else{
			$q = $db->query("select * from {$tpf}categories order by show_order asc, cate_id asc");
			$cates = array();
			while($rs = $db->fetch_array($q)){
				$cates[] = $rs;
			}
			$db->free($q);
			unset($rs);

			for($i = 0; $i < count($cates); $i++){
				if($cates[$i]['pid']==0){
					$total = @$db->result_first("select count(*) from {$tpf}files where cate_id='{$cates[$i]['cate_id']}' and is_public=1");
					$a_modify = urr("admincp","item=plugins&app=$app&action=modify_cate&cate_id={$cates[$i]['cate_id']}");
					$a_cate_href = urr("public","cate_id={$cates[$i]['cate_id']}");
					$a_del_cate = urr("admincp","item=plugins&app=$app&action=del_cate&cate_id={$cates[$i]['cate_id']}");
					$is_hidden = $cates[$i]['is_hidden'] ? '<span class="txtgray">('.$lang['is_hidden'].')</span>' : '';

					$cate_list .= '<tr>';
					$cate_list .= '	<td>';
					$cate_list .= '	<input type="text" name="show_order[]" value="'.$cates[$i]['show_order'].'" style="width:20px; text-align:center" maxlength="2" />';
					$cate_list .= '	<input type="hidden" name="cate_ids[]" value="'.$cates[$i]['cate_id'].'" />';
					$cate_list .= '	<input type="text" name="cate_names[]" value="'.$cates[$i]['cate_name'].'" />&nbsp;'.$is_hidden.'</td>';
					$cate_list .= '	<td align="center">';
					$cate_list .= '	<a href="'.$a_cate_href.'" target="_blank">'.$total.'</a>';
					$cate_list .= '	</td>';
					$cate_list .= '	<td align="right">';
					$cate_list .= '	<a href="'.$a_modify.'">'.$lang['modify'].'</a>&nbsp;';
					$cate_list .= '	<a href="'.$a_del_cate.'" onclick="return confirm(\''.$lang['del_category_confirm'].'\');">'.$lang['delete'].'</a></td>';
					$cate_list .= '</tr>';
					
					for($j = 0; $j < count($cates); $j++){
						if($cates[$j]['pid']>0 && $cates[$j]['pid'] == $cates[$i]['cate_id']){
							$total = @$db->result_first("select count(*) from {$tpf}files where cate_id='{$cates[$j]['cate_id']}' and is_public=1");
							$a_modify = urr("admincp","item=plugins&app=$app&action=modify_cate&cate_id={$cates[$j]['cate_id']}");
							$a_cate_href = urr("public","cate_id={$cates[$j]['cate_id']}");
							$a_del_cate = urr("admincp","item=plugins&app=$app&action=del_cate&cate_id={$cates[$j]['cate_id']}");
							$is_hidden = $cates[$j]['is_hidden'] ? '<span class="txtgray">('.$lang['is_hidden'].')</span>' : '';
		
							$cate_list .= '<tr>';
							$cate_list .= '	<td>';
							$cate_list .= '	&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" name="show_order[]" value="'.$cates[$j]['show_order'].'" style="width:20px; text-align:center" maxlength="2" />';
							$cate_list .= '	<input type="hidden" name="cate_ids[]" value="'.$cates[$j]['cate_id'].'" />';
							$cate_list .= '	<input type="text" name="cate_names[]" value="'.$cates[$j]['cate_name'].'" />'.$is_hidden.'</td>';
							$cate_list .= '	<td align="center">';
							$cate_list .= '	<a href="'.$a_cate_href.'" target="_blank">'.$total.'</a>';
							$cate_list .= '	</td>';
							$cate_list .= '	<td align="right">';
							$cate_list .= '	<a href="'.$a_modify.'">'.$lang['modify'].'</a>&nbsp;';
							$cate_list .= '	<a href="'.$a_del_cate.'" onclick="return confirm(\''.$lang['del_category_confirm'].'\');">'.$lang['delete'].'</a></td>';
							$cate_list .= '</tr>';
					
						}
					}
				}
			}
			require_once template_echo('admin','',$app);
		}
	
	break;

	case 'del_cate':
		if($settings['online_demo']){
			$sysmsg[] = $lang['you_no_power'];
			redirect("javascript:history.back();",$sysmsg);
		}else{
			$cate_id = (int)gpc('cate_id','G',0);
			if($cate_id){
				$db->query_unbuffered("delete from {$tpf}files where cate_id='$cate_id' and is_public=1");
				$db->query_unbuffered("delete from {$tpf}categories where cate_id='$cate_id'");
			}
			$sysmsg[] = $lang['del_cate_success'];
			redirect(urr("admincp","item=plugins&app=$app&action=category"),$sysmsg);
		}	
	break;

	default:
		$btn_status = $settings['online_demo'] ? 'disabled' : '';
		if($task == 'update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$setting = array(
				'check_public_file' => 0,
			);
			$settings = gpc('setting','P',$setting);

			if(!$error){
				
				settings_cache($settings);
				
				$sysmsg[] = $lang['public_update_success'];
				redirect(urr("admincp","item=plugins&app=$app"),$sysmsg);
			}else{
				redirect('javascript:history.back();',$sysmsg);
			}
		}else{
			$setting['check_public_file'] = $settings['check_public_file'];
			
			require_once template_echo('admin','',$app);
		}

}
update_action_time($app);
?>